monads-tf-0.3.0.1: Monad classes, using type families

Copyright | (c) Andy Gill 2001 (c) Oregon Graduate Institute of Science and Technology 2001 (c) Jeff Newbern 2003-2007 (c) Andriy Palamarchuk 2007
License | BSD-style (see the file LICENSE)
Maintainer | ross@soi.city.ac.uk
Stability | experimental
Portability | non-portable (type families)
Safe Haskell | None
Language | GHC2021

Control.Monad.Reader.Class

Description

Computation type:
  Computations which read values from a shared environment.
Binding strategy:
  Monad values are functions from the environment to a value. The bound function is applied to the bound value, and both have access to the shared environment.
Useful for:
  Maintaining variable bindings, or other shared environment.
Zero and plus:
  None.
Example type:
  ``Reader` [(String,Value)] a`

The `Reader` monad (also called the Environment monad). Represents a computation, which can read values from a shared environment, pass values from function to function, and execute sub-computations in a modified environment. Using `Reader` monad for such computations is often clearer and easier than using the `State` monad.

Inspired by the paper Functional Programming with Overloading and Higher-Order Polymorphism, Mark P Jones (http://web.cecs.pdx.edu/~mpj/) Advanced School of Functional Programming, 1995.

Synopsis

- class Monad m => MonadReader (m :: Type -> Type) where
  - type EnvType (m :: Type -> Type)
  - ask :: m (EnvType m)
  - local :: (EnvType m -> EnvType m) -> m a -> m a
- asks :: MonadReader m => (EnvType m -> a) -> m a

# Documentation

class Monad m => MonadReader (m :: Type -> Type) where Source #

See examples in Control.Monad.Reader. Note, the partially applied function type `(->) r` is a simple reader monad. See the `instance` declaration below.

Associated Types

type EnvType (m :: Type -> Type) Source #

Methods

ask :: m (EnvType m) Source #

Retrieves the monad environment.

local Source #

Arguments

:: (EnvType m -> EnvType m) | The function to modify the environment.
-> m a | `Reader` to run in the modified environment.
-> m a |

Executes a computation in a modified environment.

#### Instances

Instances details

MonadReader m => MonadReader (MaybeT m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (MaybeT m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (MaybeT m) = EnvType m

Methods

ask :: MaybeT m (EnvType (MaybeT m)) Source #

local :: (EnvType (MaybeT m) -> EnvType (MaybeT m)) -> MaybeT m a -> MaybeT m a Source #

MonadReader m => MonadReader (ExceptT e m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (ExceptT e m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (ExceptT e m) = EnvType m

Methods

ask :: ExceptT e m (EnvType (ExceptT e m)) Source #

local :: (EnvType (ExceptT e m) -> EnvType (ExceptT e m)) -> ExceptT e m a -> ExceptT e m a Source #

MonadReader m => MonadReader (IdentityT m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (IdentityT m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (IdentityT m) = EnvType m

Methods

ask :: IdentityT m (EnvType (IdentityT m)) Source #

local :: (EnvType (IdentityT m) -> EnvType (IdentityT m)) -> IdentityT m a -> IdentityT m a Source #

Monad m => MonadReader (ReaderT r m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (ReaderT r m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (ReaderT r m) = r

Methods

ask :: ReaderT r m (EnvType (ReaderT r m)) Source #

local :: (EnvType (ReaderT r m) -> EnvType (ReaderT r m)) -> ReaderT r m a -> ReaderT r m a Source #

MonadReader m => MonadReader (StateT s m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (StateT s m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (StateT s m) = EnvType m

Methods

ask :: StateT s m (EnvType (StateT s m)) Source #

local :: (EnvType (StateT s m) -> EnvType (StateT s m)) -> StateT s m a -> StateT s m a Source #

MonadReader m => MonadReader (StateT s m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (StateT s m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (StateT s m) = EnvType m

Methods

ask :: StateT s m (EnvType (StateT s m)) Source #

local :: (EnvType (StateT s m) -> EnvType (StateT s m)) -> StateT s m a -> StateT s m a Source #

(Monoid w, MonadReader m) => MonadReader (WriterT w m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (WriterT w m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (WriterT w m) = EnvType m

Methods

ask :: WriterT w m (EnvType (WriterT w m)) Source #

local :: (EnvType (WriterT w m) -> EnvType (WriterT w m)) -> WriterT w m a -> WriterT w m a Source #

(Monoid w, MonadReader m) => MonadReader (WriterT w m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (WriterT w m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (WriterT w m) = EnvType m

Methods

ask :: WriterT w m (EnvType (WriterT w m)) Source #

local :: (EnvType (WriterT w m) -> EnvType (WriterT w m)) -> WriterT w m a -> WriterT w m a Source #

MonadReader m => MonadReader (ContT r m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (ContT r m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (ContT r m) = EnvType m

Methods

ask :: ContT r m (EnvType (ContT r m)) Source #

local :: (EnvType (ContT r m) -> EnvType (ContT r m)) -> ContT r m a -> ContT r m a Source #

MonadReader ((->) r) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType ((->) r) |
Instance details Defined in Control.Monad.Reader.Class type EnvType ((->) r) = r

Methods

ask :: r -> EnvType ((->) r) Source #

local :: (EnvType ((->) r) -> EnvType ((->) r)) -> (r -> a) -> r -> a Source #

(Monoid w, Monad m) => MonadReader (RWST r w s m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (RWST r w s m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (RWST r w s m) = r

Methods

ask :: RWST r w s m (EnvType (RWST r w s m)) Source #

local :: (EnvType (RWST r w s m) -> EnvType (RWST r w s m)) -> RWST r w s m a -> RWST r w s m a Source #

(Monoid w, Monad m) => MonadReader (RWST r w s m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (RWST r w s m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (RWST r w s m) = r

Methods

ask :: RWST r w s m (EnvType (RWST r w s m)) Source #

local :: (EnvType (RWST r w s m) -> EnvType (RWST r w s m)) -> RWST r w s m a -> RWST r w s m a Source #

asks Source #

Arguments

:: MonadReader m |
=> (EnvType m -> a) | The selector function to apply to the environment.
-> m a |

Retrieves a function of the current environment.